(function () {
    "use strict";

    angular.module('core').controller('homeOperacaoController', controller);
    controller.$inject = ['$scope', '$filter', '$timeout', 'configService'];

    function controller($scope, $filter, $timeout, configService) {
        $scope.initializeLayout('Operação');

        $scope.state = {
            principal: [],
            secundario: [],
        };

        /* funções */
        $scope.initialize = function () {
            $scope.searchkey = localStorage.getItem('homeOperacao.searchkey');
            if (!$scope.searchkey)
                $scope.clearFilter();

            $scope.refresh();
        };

        $scope.getAllNavegacaoPrincipal = function () {
            configService.getAllNavegacaoPrincipal('Operação')
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.principal);
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.getAllNavegacaoSecundario = function () {
            configService.getAllNavegacaoSecundario('Operação')
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.secundario);
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };

        $scope.setSearchKey = function () {
            localStorage.setItem('homeOperacao.searchkey', $scope.searchkey);
        };
        $scope.clearFilter = function () {
            $scope.searchkey = '';
            localStorage.removeItem('homeOperacao.searchkey');
            $timeout(function () { $('[ng-model="searchkey"]').focus(); });
        };

        $scope.refresh = function () {
            $scope.getAllNavegacaoPrincipal();
            $scope.getAllNavegacaoSecundario();
        };

        $scope.clear = async () => {
            $scope.clearFilter();
            $scope.refresh();
        };

        $scope.initialize();

    }

})();